%define pkgname jabberd
%define conference_version 0.6.0
%define jud_version 0.5
# this is a "stable" snapshot from 2003-03-14 (version > 0.9.24c)
%define aim_version 20040131
# 1.3.0 == 2005-04-25
%define msn_version 1.3.0
%define yahoo_version 2.3.2

%define lib_name %mklibname jabberd 0

Summary: Instant messaging System
Name: jabber
Version: 1.4.4
Release: %mkrel 16
Source0: http://jabberd.jabberstudio.org/1.4/dist/%{pkgname}-%{version}.tar.bz2
Source2: jabber.initrd
Source3: jabber.cfg.bz2
Source6: jabber-aim.xml.bz2
Source7: jabber-aim.initrd
Source8: jabber-gentestcrt.sh
Source10: mu-conference-%{conference_version}.tar.bz2
Source11: jud-%{jud_version}.tar.bz2

Source12: jabber-1.4.2-manpage.bz2

Source13: jabber-conference.xml.bz2
Source14: jabber-conference.initrd

Source15: jabber-msn.xml.bz2
Source16: jabber-msn.initrd
Source17: jud.xml.bz2

# transports sources
Source20: http://aim-transport.jabberstudio.org/aim-transport-stable-%{aim_version}.tar.bz2
Source22: http://msn-transport.jabberstudio.org/msn-transport-%{msn_version}.tar.bz2
Source23: http://www.jabberstudio.org/projects/yahoo-transport-2/releases/yahoo-transport-%{yahoo_version}.tar.bz2

# default configuration
Patch0:  jabber-1.4.4-xmlconfig.patch
Patch1:  libjabber-fix-includes.patch
# (fc) 1.4.3-11mdk fix build with gcc4
Patch8:  jabber-1.4.4-gcc4.patch
# (fc) 1.4.4-1mdk fix build for old transport with jabber 1.4.4
Patch9:  jabber-1.4.4-fixbuild.patch
# (fc) 1.4.4-1mdk fix soname for dlopened libraries
Patch10: jabber-1.4.4-soname.patch
# (gb) 1.4.4-4mdk build DSO with PIC
Patch11: jabber-1.4.4-pic.patch
# (cb) 2.3.2 use glib2 for yahoo transport
Patch12: yahoo-transport-2.3.2-glib2.patch
# (fc) 1.4.4-11mdv correctly initialize openssl
Patch13: jabber-openssl098.patch

License: Jabber Open Source License/GPL
URL: http://jabberd.jabberstudio.org/
Group: System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
# used in initscripts but that should be implicit nowadays
Requires: file
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  pth-devel
BuildRequires:	curl-devel >= 7.12.0
BuildRequires:	openssl-devel
BuildRequires:  glib2-devel
BuildRequires:	automake1.4
BuildRequires:	automake1.9
BuildRequires:	gettext-devel
BuildRequires:	libidn-devel
BuildRequires:	libexpat-devel

%description
This package provides a Jabber server.
Jabber is an instant messaging System, similar to ICQ or AIM, yet far 
different. 
It is open source, absolutely free, simple, fast, extensible, modularized, 
cross platform, and created with the future in mind. Jabber has been 
designed from the ground up to serve the needs of the end user, satisfy 
business demands, and maintain compatibility with other messaging systems.
%package -n %lib_name
Summary:	Shared library used by jabber
Group:		System/Libraries

%description -n %lib_name
Shared library used by Jabber server.

%package -n %lib_name-devel
Summary:	Includes files and library used to develop for jabber
Group:		Development/C
Requires: %{lib_name} = %{version}
Provides: libjabberd-devel = %{version}-%{release}

%description -n %lib_name-devel
Includes files and library used to develop for jabber

%package conference
Summary:	Conferencing service for Jabber server
Group:		System/Servers
Requires:	%{name} = %{version}
Requires(post): rpm-helper
Requires(preun): rpm-helper

%description conference
This package contains conference servicing for Jabber server.

WARNING : to enable support for this transport, you must :
- uncomment conference part in /etc/jabber/jabber.xml 
- edit /etc/jabber/jabber.xml and  /etc/jabber/jabber-conference.xml 
  to replace conference.localhost with 
  conference.your_computer_full_domain_name
- configure our DNS server to resolve conference.your_computer_full_domain_name


%package jud
Summary:	Jabber User Directory service for Jabber server
Group:		System/Servers
Requires:	%{name} = %{version}

%description jud
This package contains service directory servicing for Jabber server.

Read the documentation for install this service.


%package aim
Summary:	Aim Transport for Jabber server
Group:		System/Servers
Requires:	%{name} = %{version}
Requires(post): rpm-helper
Requires(preun): rpm-helper
Obsoletes:	jabber-icq
Provides:	jabber-icq

%description aim
This package contains aim transport for Jabber server.

Read the documentation for install this transport.

WARNING : to enable support for this transport, you must :
- uncomment aim part in /etc/jabber/jabber.xml 
- edit /etc/jabber/jabber.xml and /etc/jabber/jabber-aim.xml to 
replace aim.localhost with aim.your_computer_full_domain_name
- configure our DNS server to resolve aim.your_computer_full_domain_name

%package msn
Summary:	Msn Transport for Jabber server
Group:		System/Servers
Requires:	%{name} = %{version}
Requires(post): rpm-helper
Requires(preun): rpm-helper

%description msn
This package contains msn transport for Jabber server.

Read the documentation for install this transport.


%package yahoo
Summary:	Yahoo Transport for Jabber server
Group:		System/Servers
Requires:	%{name} = %{version}

%description yahoo
This package contains yahoo transport for Jabber server.

Read the documentation for install this transport.


%prep 
%setup -q -a 10 -a 11 -a 20 -a 22 -a 23  -n %{pkgname}-%{version}
%patch0 -p 1 -b .xmlconfig
%patch1 -p 1 -b .fixinclude
%patch8 -p 1 -b .gcc4
%patch9 -p 1 -b .fixbuild
%patch10 -p1 -b .soname
%patch13 -p1 -b .openssl098

# needs to be applied last since it patches plugins too
%patch11 -p1 -b .pic
%patch12 -p0 -b .glib2

#needed by patches 9 & 10
aclocal
automake
autoconf
#needed by patch7 & 9
cd aim-transport-stable-%{aim_version}
touch NEWS
automake-1.4 -a
autoconf
cd ..
cd msn-transport-1.*
touch NEWS ChangeLog
aclocal
automake -a
autoconf
cd ..

%build
%serverbuild

%configure2_5x --without-mysql --without-postgresql --enable-legacy \
 --sysconfdir=%{_sysconfdir}/jabber --localstatedir=%{_var} --libdir=%{_libdir}/jabber --bindir=%{_sbindir} --without-ipv6 --without-mysql --without-postgresql --enable-ssl
#parallel build is broken
make 

cd jud-ansi-c
make
cd ..

cd mu-conference-%{conference_version}
make
cd ..

cd aim-transport-stable-%{aim_version}
%configure2_5x
make
cd ..

cd msn-transport-1.*
%configure2_5x --with-jabberd=$RPM_BUILD_DIR/%{pkgname}-%{version}/jabberd --with-pth=%{_includedir} --with-curl-libs=%{_libdir}

make
cd ..

cd yahoo-transport-%{yahoo_version}
make
cd ..



%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std spooldir=%{_localstatedir}/jabber
mv $RPM_BUILD_ROOT%{_libdir}/jabber/libjabberd.* $RPM_BUILD_ROOT%{_libdir}

bzcat %{SOURCE3} > $RPM_BUILD_ROOT%{_sysconfdir}/jabber/jabber.cfg
install -m 755 %{SOURCE8} $RPM_BUILD_ROOT%{_libdir}/jabber/jabber-gentestcrt.sh

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
bzcat %{SOURCE12} >  $RPM_BUILD_ROOT%{_mandir}/man8/jabberd.8

mkdir -p $RPM_BUILD_ROOT/%{_initrddir} $RPM_BUILD_ROOT%{_sysconfdir}/ssl/jabber
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/%{_initrddir}/jabber
touch $RPM_BUILD_ROOT/%{_sysconfdir}/ssl/jabber/key.pem

cat << EOF > README.ssl
A SSL test key has been generated as /etc/ssl/jabber/key.pem

To enable SSL support in Jabber, you must modify /etc/jabber/jabber.xml :
-uncomment one of the lines <ssl port='5223'>127.0.0.1</ssl> by adding your 
server IP address (Be sure to include an IP address otherwise, you will get 
nothing but a 1Gb error logfile
-uncomment one of the lines  <key ip='127.0.0.1'>/etc/ssl/jabber/key.pem</key> and replace 127.0.0.1 with your server IP address
EOF

#jabber service
mkdir -p $RPM_BUILD_ROOT%{_libdir}/jabber/mu-conference
install -m 755 mu-conference-%{conference_version}/src/mu-conference.so $RPM_BUILD_ROOT%{_libdir}/jabber/mu-conference
bzcat %{SOURCE13} | sed -e 's|@libdir@|%{_libdir}/jabber/|g' > $RPM_BUILD_ROOT%{_sysconfdir}/jabber/jabber-conference.xml
install -m 755 %{SOURCE14} $RPM_BUILD_ROOT/%{_initrddir}/jabber-conference


mkdir -p $RPM_BUILD_ROOT%{_libdir}/jabber/jud
install -m 755 jud-ansi-c/jud.so $RPM_BUILD_ROOT%{_libdir}/jabber/jud
bzcat %{SOURCE17} | sed -e 's|@libdir@|%{_libdir}/jabber/|g' > $RPM_BUILD_ROOT%{_sysconfdir}/jabber/jud.xml

# transports

# aim-transport 
mkdir -p $RPM_BUILD_ROOT%{_libdir}/jabber/aim-transport
install -m 755 aim-transport-stable-%{aim_version}/src/aimtrans.so $RPM_BUILD_ROOT%{_libdir}/jabber/aim-transport
bzcat %{SOURCE6} | sed -e 's|@libdir@|%{_libdir}/jabber/|g' > $RPM_BUILD_ROOT%{_sysconfdir}/jabber/jabber-aim.xml
install -m 755 %{SOURCE7} $RPM_BUILD_ROOT/%{_initrddir}/jabber-aim

# msn-transport 
mkdir -p $RPM_BUILD_ROOT%{_libdir}/jabber/msn-transport
install -m 755 msn-transport-1.*/src/msntrans.so $RPM_BUILD_ROOT%{_libdir}/jabber/msn-transport
bzcat %{SOURCE15}| sed -e 's|@libdir@|%{_libdir}/jabber/|g' > $RPM_BUILD_ROOT%{_sysconfdir}/jabber/jabber-msn.xml
install -m 755 %{SOURCE16} $RPM_BUILD_ROOT/%{_initrddir}/jabber-msn


# yahoo-transport 
mkdir -p $RPM_BUILD_ROOT%{_libdir}/jabber/yahoo-transport
install -m 755 yahoo-transport-%{yahoo_version}/yahoo-transport.so $RPM_BUILD_ROOT%{_libdir}/jabber/yahoo-transport

#remove unpackaged files
rm -f $RPM_BUILD_ROOT%{_libdir}/jabber/*.la \
 $RPM_BUILD_ROOT%{_libdir}/jabber/libjabberdxdbsql.*

%clean
rm -rf $RPM_BUILD_ROOT

%post 
if [ ! -f %{_sysconfdir}/ssl/jabber/key.pem ]; then
 pushd %{_sysconfdir}/ssl/jabber/ > /dev/null
 yes "" | %{_libdir}/jabber/jabber-gentestcrt.sh > /dev/null 2> /dev/null
 cat %{_sysconfdir}/ssl/jabber/server.crt %{_sysconfdir}/ssl/jabber/server.key > %{_sysconfdir}/ssl/jabber/key.pem
 rm -f %{_sysconfdir}/ssl/jabber/server.*
 chmod 500 %{_sysconfdir}/ssl/jabber/key.pem
 chown daemon.daemon %{_sysconfdir}/ssl/jabber/key.pem
 popd > /dev/null
fi
%_post_service jabber


%preun
%_preun_service jabber

%post aim
%_post_service jabber-aim

%preun aim
%_preun_service jabber-aim

%post conference
%_post_service jabber-conference

%preun conference
%_preun_service jabber-conference

%post msn
%_post_service jabber-msn

%preun msn
%_preun_service jabber-msn

%post -n %lib_name -p /sbin/ldconfig

%postun -n %lib_name -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README README.ssl README.config README.karma README.protocols
%dir %{_sysconfdir}/jabber
%dir %{_sysconfdir}/ssl/jabber
%attr(644,daemon,daemon) %config(noreplace) %{_sysconfdir}/jabber/jabber.xml
%attr(644,daemon,daemon) %config(noreplace) %{_sysconfdir}/jabber/jabber.xml.dist
%attr(755,daemon,daemon) %config(noreplace) %{_sysconfdir}/jabber/jabber.cfg
%attr(500,daemon,daemon) %ghost %{_sysconfdir}/ssl/jabber/key.pem
%{_initrddir}/jabber
%dir %{_libdir}/jabber
%{_libdir}/jabber/*.so
%attr(755,root,root) %{_libdir}/jabber/jabber-gentestcrt.sh
%{_sbindir}/*
%{_mandir}/man5/*
%{_mandir}/man8/*
%attr(700,daemon,daemon) %dir %{_localstatedir}/jabber
%attr(750,daemon,daemon) %dir /var/log/jabberd
%attr(700,daemon,daemon) %dir /var/run/jabberd

%files -n %lib_name
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %lib_name-devel
%defattr(-,root,root)
%{_libdir}/*.so
%{_libdir}/*.la
%{_includedir}/*



%files conference
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc mu-conference-%{conference_version}/README 
%{_initrddir}/jabber-conference
%config(noreplace) %{_sysconfdir}/jabber/jabber-conference.xml
%{_libdir}/jabber/mu-conference

%files jud
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc jud-ansi-c/README
%config(noreplace) %{_sysconfdir}/jabber/jud.xml
%{_libdir}/jabber/jud

%files aim
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc aim-transport-stable-%{aim_version}/README
%{_sysconfdir}/jabber/jabber-aim.xml
%config(noreplace) %{_initrddir}/jabber-aim
%{_libdir}/jabber/aim-transport

%files msn
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc msn-transport-1.*/README
%{_libdir}/jabber/msn-transport
%{_initrddir}/jabber-msn
%config(noreplace) %{_sysconfdir}/jabber/jabber-msn.xml

%files yahoo
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc yahoo-transport-%{yahoo_version}/*.xml yahoo-transport-%{yahoo_version}/INSTALL
%{_libdir}/jabber/yahoo-transport


%changelog
* Mon Feb 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.4.4-16mdv2008.1
+ Revision: 170904
- rebuild
- fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake
- fix description-line-too-long

* Sun Jan 13 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.4.4-15mdv2008.1
+ Revision: 150352
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Thu Sep 13 2007 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-14mdv2008.0
+ Revision: 84952
- Fix groups for lib and devel packages (Mdv bug #28163)

* Fri Jun 08 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 1.4.4-13mdv2008.0
+ Revision: 37265
- rebuild for expat


* Tue Jan 16 2007 Nicolas Lécureuil <neoclust@mandriva.org> 1.4.4-12mdv2007.0
+ Revision: 109481
- Rebuild against new curl

  + Götz Waschk <waschk@mandriva.org>
    - remove obsolete buildrequires on libsigc++-devel

* Thu Nov 02 2006 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-11mdv2007.1
+ Revision: 75610
- Bunzip patches
  Patch13: fix ssl support with openssl 0.9.8 (Mdv bug #26940)
- Import jabber

* Wed Aug 09 2006 Jerome Soyer <saispo@mandriva.org> 1.1.4-10mdv2007.0
- Fix #23638 with cris patch

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 1.4.4-9mdk
- fix typo in initscripts

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 1.4.4-8mdk
- convert parallel init to LSB
- make the description mention it's a server

* Tue Jan 03 2006 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-7mdk
- Update sources 2, 7, 14, 16 for parallel initscript
- use mkrel

* Mon Nov 14 2005 Oden Eriksson <oeriksson@mandriva.com> 1.4.4-6mdk
- rebuilt against openssl-0.9.8a

* Sun Sep 11 2005 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-5mdk 
- Ensure ssl is enabled
- Update aim and msn configuration file with more options
- Update aim and msn initscript to remove pid file when stopping

* Tue Aug 23 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.4.4-4mdk
- build DSO with PIC

* Fri Aug 19 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.4.4-3mdk
- add BuildRequires: gettext-devel libidn-devel libexpat-devel

* Wed Aug 10 2005 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-2mdk 
- Update patch8 with another fix from SVN

* Tue Aug 09 2005 Frederic Crozat <fcrozat@mandriva.com> 1.4.4-1mdk 
- Release 1.4.4 aka finally using auto* tools
- Update patch8 to fix crash with gcc4
- Remove patches 4, 6 (no longer needed)
- Update all configuration and initrd files to remove lib64 stuff

* Sun Aug 07 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.4.3-12mdk
- Patch9: don't use automake 1.6; use 1.7 and add it as buildrequires

* Sat Aug 06 2005 Frederic Crozat <fcrozat@mandriva.com> 1.4.3-11mdk 
- Update patch0 to not comment host value (David Walser)
- update msn transport to 1.3.0
- Update yahoo transport to 2.3.2
- Patch8 (Debian BTS): fix build with gcc 4
- regenerate patch7
- clean specfile

* Fri Mar 11 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.4.3-10mdk
- add BuildRequires: automake1.4

* Fri Mar 04 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4.3-9mdk 
- add configuration for JUD (Scott) (Mdk bug #14215)
- update msn transport to 1.3cvs4 ie 20040716
- Regenerate patch7

* Tue Aug 03 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 1.4.3-8mdk
- Rebuild for new curl

* Fri May 21 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4.3-7mdk
- MSN Transport CVS snapshot 20040412
- AIM transport CVS snapshot 20040131
- Yahoo transport 2.3.1
- Remove ICQ transport, AIM transport can do the job (Mdk bug 9124)
- No longer rotate log, jabber doesn't like that (Mdk bug 9295)
- Regenerate patch7

* Fri Apr 16 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4.3-6mdk
- poor man's lib64 fixes

* Mon Mar 22 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4.3-5mdk
- Update source 5 : fix Mdk bug #9123
- Update source 14 : fix Mdk bugs #9092 & #9094
- Update source 13 : fix typo in default configuration file
- Update patch0 : fix typo in default configuration file

